/*
	ATMEL FLASH programming and verification demo for E31.
	(C) MicroLAB Systems, 1997

*/



#define	ML_OFF			0
#define	ML_ON			1

#include	<math.h>
#include	"c30_def.h"



int *PB_C	= (int *)0x808064;


int *SRAM	= (int *)0x100000;
int *FLASH	= (int *)0x400000;
int *USART	= (int *)0xA00000;
int *PIOX	= (int *)0xC00000;



cpu_init()
 {
	*PBUS_C = 0x700;
	CACHE_ENABLE;
	INT_DISABLE;

	asm(" ldi 22H,iof");

 }


#define	FLASH_DATA_START_PTR	0x410000	/* use +0x10000 address sector for test */
#define FLASH_DATA_LEN		0x100           /* sector length */
#define FLASH_DATA_START_DATA	0x0		/* start data value for increment */

int *fptr;
int data;

void main()
{
	int i;

	cpu_init();

    	/* ---------- FLASH programming loop
	   (should guarantee less than 150us between FLASH accessed
         */
	for (i=0, fptr= (int *) FLASH_DATA_START_PTR , data=FLASH_DATA_START_DATA;
	     i<FLASH_DATA_LEN;
	     i++, data++, fptr++)
	 {
	    *fptr= data;
	 }


    	/* ---------- wait for end of FLASH internal programming SM
         */
	data--;		/* restore last programmed DATA value and PTR */
        fptr--;
	while ( ((*fptr) & 0x80)!= (data & 0x80)); /* use inversed DATA poll method for FLASH-7 bit */

	
    	/* ---------- FLASH verification loop
         */
	for (i=0, fptr= (int *) FLASH_DATA_START_PTR , data=FLASH_DATA_START_DATA;
	     i<FLASH_DATA_LEN;
	     i++, data++, fptr++)
	 {
	    if ( ((*fptr) & 0xff)!= data) goto error ;
	 }

halt_ok:        /* TRAP here in case programming & verification is OK */
   while(1);	

error:
   while(1);	/* TRAP here in case of verification error */

}
