/****************************************************
  SIOX-A rev.C r/w test for E3x

  Notes:
    1. This test checks for R/W buffers of PIOX.
       DO NOT APPLY ANY OSCILLOSCOPE NODES to the PIOX
       DATA BUS! (data are assumed to stay precharged on the
       PIOX output data buffers).

    2. TIMER-0 output is used as the progress indicator
       and generates square output if OK.

*****************************************************/

#include "c3x_def.h"
#include "te3x_dsp.h"


init_cpu()
{
	*C3X_PBUS_GC=TE3X_PBUS_GC_DATA;

}


unsigned *ptr;

#define TM_OUT_0  2
#define TM_OUT_1  6



main()
{
   unsigned  int d, dr, i, count;

   init_cpu();

   ptr=(unsigned *)TE3X_SIOX_SADDR;
   count=0;
   *C3X_TM0_GC = TM_OUT_0;
   *C3X_TM1_GC = TM_OUT_0;

   while(1)
    {
      for(d=0x1L, i=0; i<8 ; i++)
	{ *ptr = d;
          if( ((*ptr)&0xff)!=d) goto error;
	  d= (d<<1);
	}

      if((count%2)==0)
	   *C3X_TM0_GC = TM_OUT_0;
	 else
	   *C3X_TM0_GC = TM_OUT_1;

      if(count==0)
	   *C3X_TM1_GC = TM_OUT_0;
	 else
	   *C3X_TM1_GC = TM_OUT_1;

      count++;
      count %=4;
    }

  error:
    while(1);
	
}



