/*
	USART_A ASYNC test for E31.

*/



#define	ML_OFF			0
#define	ML_ON			1

#define	PI			3.141592

#include	<math.h>
#include	"c30_def.h"



int *PB_C	= (int *)0x808064;


int *SRAM	= (int *)0x100000;
int *EPROM	= (int *)0x400000;
int *USART_A	= (int *)0xA00000;
int *PIOX	= (int *)0xC00000;





int *USART_PCR	= (int *)0xA0003e;
int *USART_PVR	= (int *)0xA0003c;


#define	CCR0	0x2c
#define	CCR1	0x2d
#define	CCR2	0x2e
#define	CCR3	0x2f
#define	MODE	0x22
#define	DAFO	0x27
#define	RFC	0x28
#define	BGR	0x34
#define	STAR	0x20
#define	CMDR	0x20
#define	TIC	0x35

#define	GIS	0x38
#define	IPC	0x39
#define	ISR1	0x3b
#define	IMR1	0x3b




char welcome[]	= "Welcome to E31 USART#A \n\n>>";
char cts_low[]	= "<< RTS: CTS=LOW >>";
char cts_high[]	= "<< RTS: CTS=HIGH >>";
char dsr_low[]	= "<< DTR: DSR=LOW >>";
char dsr_high[]	= "<< DTR: DSR=HIGH >>";




cpu_init()
 {
	/* set PIOX WS for Primary BUS: mode=XRDY, bank_size=256K
        */
	   *PBUS_C = 0x600;
	CACHE_ENABLE;
	INT_DISABLE;


	*USART_PCR	= 0;  /*configure all pins as outputs */

        USART_A[CCR0]	= 0x0;
	USART_A[MODE]	= 0x0;

        USART_A[CCR0]	= 0x43; /* MCE, ASYNC */
	USART_A[CCR1]	= 0x1f; /* ODS, BCR, clk_mode=7 */
	USART_A[CCR2]	= 0x38; /* BDF, SSEL (clk_mode=7b), TCLK = out */
	USART_A[DAFO]	= 0x00; /* STOP=1, PARity=OFF, 8bit */
	USART_A[RFC]	= 0x0;  /* RFIFO threshold = 1 */
        USART_A[BGR]	= 0x5;	/* 9600 bauds */

        USART_A[CCR0]	|= 0x80;/* PU: set channel activity */
	USART_A[CMDR]	= 0x41; /* receiver/transmitter reset */
	USART_A[MODE]	= 0xc;	/* receiver active, set RTS */

	USART_A[IPC]	= 0x81;	/* set unmasked irqs visible, irq active low */
	USART_A[GIS]	= 0x8;	/* enable IRQS from IRQ1/USART-A */
	USART_A[IMR1]	= ~0x21;/* enable IRQS from ALLS/XPR */

 }

#define WAIT_CMDR_READY   {while (USART_A[STAR] &0x4);}

uart_transmit_char(c)
int c;
{


/* transmit using XPR irq with bits ALLS/XPR from ISR1 */
  while (!(USART_A[ISR1] &0x21));
  *USART_A=c;
  WAIT_CMDR_READY;
  USART_A[CMDR]=0x8;

/* transmission using TIC: runs well always
  while ((USART_A[STAR] &0x8));
  USART_A[TIC]=c;
*/
}


int uart_receive_char()
{ int c;

  while (!(USART_A[STAR] &0x20));
  c=*USART_A & 0xff;
  WAIT_CMDR_READY;
  USART_A[CMDR]=0x80;	/* release RFIFO */
  return(c);
}


int uart_receiver_status()
{
  return((USART_A[STAR] & 0x20) ? 1:0);
}


uart_transmit_mess(s)
char *s;
{
  while((*s &0xff)!=0) uart_transmit_char(*(s++));

/* transmit using full XFIFO: runs well
  WAIT_CMDR_READY;
  while((*s &0xff)!=0 && (USART_A[STAR] &0x40)) *USART_A=*(s++);
  USART_A[CMDR]=0x8;
*/
}





void main()
{
	int modem_status;

	cpu_init();

        uart_transmit_mess(welcome);


        while (1)
	 {
	   if(uart_receiver_status()==ML_ON)
              uart_transmit_char(uart_receive_char());
	 }





}



